'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = require('react');
var React__default = _interopDefault(React);
var propTypes = require('prop-types');
var firebase = _interopDefault(require('@firebase/app'));
require('@firebase/auth');
require('@firebase/firestore');
require('@firebase/messaging');
require('@firebase/storage');

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) {
  return typeof obj;
} : function (obj) {
  return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
};











var classCallCheck = function (instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
};

var createClass = function () {
  function defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  return function (Constructor, protoProps, staticProps) {
    if (protoProps) defineProperties(Constructor.prototype, protoProps);
    if (staticProps) defineProperties(Constructor, staticProps);
    return Constructor;
  };
}();





var defineProperty = function (obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
};

var _extends = Object.assign || function (target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i];

    for (var key in source) {
      if (Object.prototype.hasOwnProperty.call(source, key)) {
        target[key] = source[key];
      }
    }
  }

  return target;
};



var inherits = function (subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      enumerable: false,
      writable: true,
      configurable: true
    }
  });
  if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
};











var possibleConstructorReturn = function (self, call) {
  if (!self) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return call && (typeof call === "object" || typeof call === "function") ? call : self;
};



















var toConsumableArray = function (arr) {
  if (Array.isArray(arr)) {
    for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) arr2[i] = arr[i];

    return arr2;
  } else {
    return Array.from(arr);
  }
};

var BATCH_ACTION = 'BATCH';

var isPlainAction = function isPlainAction(action) {
  return (typeof action === 'undefined' ? 'undefined' : _typeof(action)) === 'object' && typeof action.type === 'string';
};

var actionBatch = function actionBatch(actions) {
  var meta = actions.reduce(function (obj, action) {
    if (_typeof(action.meta) === 'object') {
      Object.assign(obj, action.meta);
    }
    return obj;
  }, {});
  return {
    type: BATCH_ACTION,
    payload: actions,
    meta: meta
  };
};

var batchMiddleware = function batchMiddleware(_ref) {
  var dispatch = _ref.dispatch;
  return function (next) {
    return function (actions) {
      if (Array.isArray(actions)) {
        var plainActions = [];
        actions.forEach(function (action) {
          if (typeof action === 'function') {
            dispatch(action);
          } else if (isPlainAction(action)) {
            plainActions.push(action);
          }
        });
        return plainActions.length ? next(actionBatch(plainActions)) : undefined;
      } else {
        return next(actions);
      }
    };
  };
};

var batchReducer = function batchReducer(reducer) {
  return function (state, action) {
    return action && action.type === BATCH_ACTION ? action.payload.reduce(reducer, state) : reducer(state, action);
  };
};

var connect = function connect(getSelectors) {
  return function (WrappedComponent) {
    var _class, _temp, _initialiseProps;

    return _temp = _class = function (_Component) {
      inherits(_class, _Component);

      function _class(props, context) {
        classCallCheck(this, _class);

        var _this = possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, props, context));

        _initialiseProps.call(_this);

        _this.state = {};
        return _this;
      }

      createClass(_class, [{
        key: 'componentWillMount',
        value: function componentWillMount() {
          var _this2 = this;

          var _context$firebase = this.context.firebase,
              auth$$1 = _context$firebase.auth,
              firestore$$1 = _context$firebase.firestore,
              select = _context$firebase.select,
              selectStorage = _context$firebase.selectStorage,
              storage$$1 = _context$firebase.storage,
              store = _context$firebase.store;

          var selector = function selector(ref, options) {
            if ('firestore' in ref) {
              // $FlowFixMe
              return select(ref, options);
            } else if ('storage' in ref) {
              // $FlowFixMe
              return selectStorage(ref, options);
            }
            throw new Error('Invalid object sent to select.');
          };
          var querySelectors = getSelectors(selector, { auth: auth$$1, firestore: firestore$$1, storage: storage$$1 }, this.props);
          this._selectors = Object.keys(querySelectors).reduce(function (memo, propName) {
            var selector = querySelectors[propName];
            memo[propName] = typeof selector === 'function' ? selector() : selector;
            return memo;
          }, {});
          this._unsubscribe = store.subscribe(this._handleState);
          var storeState = store.getState();
          this.setState(function (state) {
            return _this2._reduceSelectors(storeState, state);
          });
        }
      }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
          if (this._unsubscribe) {
            this._unsubscribe();
            this._unsubscribe = null;
          }
        }
      }, {
        key: 'render',
        value: function render() {
          var _context$firebase2 = this.context.firebase,
              auth$$1 = _context$firebase2.auth,
              firestore$$1 = _context$firebase2.firestore,
              messaging$$1 = _context$firebase2.messaging,
              storage$$1 = _context$firebase2.storage;

          return React__default.createElement(WrappedComponent, _extends({}, this.props, this.state, {
            auth: auth$$1,
            firestore: firestore$$1,
            messaging: messaging$$1,
            storage: storage$$1
          }));
        }
      }]);
      return _class;
    }(React.Component), _class.displayName = 'Connect', _class.WrappedComponent = WrappedComponent, _class.contextTypes = {
      firebase: propTypes.object.isRequired
    }, _initialiseProps = function _initialiseProps() {
      var _this3 = this;

      this._handleState = function () {
        if (_this3._unsubscribe) {
          var _store = _this3.context.firebase.store;

          var storeState = _store.getState();
          _this3.setState(function (state) {
            return _this3._reduceSelectors(storeState, state);
          });
        }
      };

      this._reduceSelectors = function (storeState, state) {
        return Object.keys(_this3._selectors).reduce(function (memo, key) {
          var selector = _this3._selectors[key];
          state[key] = typeof selector === 'function' ? selector(storeState, _this3.props) : selector;
          return state;
        }, state);
      };
    }, _temp;
  };
};

var FetchStatus = {
  LOADING: 'loading',
  LOADED: 'loaded',
  FAILED: 'failed',
  NONE: 'none'
};

var resolveInitialFetchStatus = function resolveInitialFetchStatus() {
  for (var _len = arguments.length, items = Array(_len), _key = 0; _key < _len; _key++) {
    items[_key] = arguments[_key];
  }

  var statuses = items.map(function (item) {
    return item.fetchStatus;
  });
  if (statuses.some(function (status) {
    return status === FetchStatus.LOADED;
  })) {
    return FetchStatus.LOADED;
  }
  if (statuses.some(function (status) {
    return status === FetchStatus.LOADING;
  })) {
    return FetchStatus.LOADING;
  }
  if (statuses.some(function (status) {
    return status === FetchStatus.FAILED;
  })) {
    return FetchStatus.FAILED;
  }
  return FetchStatus.NONE;
};

var resolveFetchStatus = function resolveFetchStatus() {
  for (var _len2 = arguments.length, items = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
    items[_key2] = arguments[_key2];
  }

  var statuses = items.map(function (item) {
    return item.fetchStatus;
  });
  if (statuses.some(function (status) {
    return status === FetchStatus.FAILED;
  })) {
    return FetchStatus.FAILED;
  }
  if (statuses.some(function (status) {
    return status === FetchStatus.LOADING;
  })) {
    return FetchStatus.LOADING;
  }
  if (statuses.every(function (status) {
    return status === FetchStatus.LOADED;
  })) {
    return FetchStatus.LOADED;
  }
  return FetchStatus.NONE;
};

var emptyObject = {};

var connectAuth = function connectAuth(handleAuthStatus, WrappedLoadingComponent) {
  return function (WrappedComponent) {
    var _class, _temp;

    return _temp = _class = function (_Component) {
      inherits(_class, _Component);

      function _class(props, context) {
        classCallCheck(this, _class);

        var _this = possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, props, context));

        _this._handleState = function () {
          if (_this._unsubscribe) {
            var _this$context$firebas = _this.context.firebase,
                _auth = _this$context$firebas.auth,
                _selectAuth = _this$context$firebas.selectAuth,
                _store = _this$context$firebas.store;

            var _selectAuth2 = _selectAuth(_store.getState()),
                _doc = _selectAuth2.doc,
                _fetchStatus = _selectAuth2.fetchStatus;

            if (handleAuthStatus && !_this._loaded && _fetchStatus === FetchStatus.LOADED) {
              var blockHandling = handleAuthStatus({ doc: _doc, fetchStatus: _fetchStatus }, _auth, _this.props);
              if (blockHandling === false) {
                return;
              }
            }
            _this.setState(function () {
              return { doc: _doc, fetchStatus: _fetchStatus };
            });
          }
        };

        _this.state = { doc: emptyObject, fetchStatus: FetchStatus.LOADING };
        _this._loaded = false;
        return _this;
      }

      createClass(_class, [{
        key: 'componentWillMount',
        value: function componentWillMount() {
          var store = this.context.firebase.store;

          this._unsubscribe = store.subscribe(this._handleState);
          this._handleState();
        }
      }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
          if (this._unsubscribe) {
            this._unsubscribe();
            this._unsubscribe = null;
          }
        }
      }, {
        key: 'componentWillUpdate',
        value: function componentWillUpdate(nextProps, nextState) {
          var prevState = this.state;
          var auth$$1 = this.context.firebase.auth;

          if (nextState.fetchStatus === FetchStatus.LOADED || nextState.fetchStatus === FetchStatus.FAILED) {
            this._loaded = true;
          }
          if (handleAuthStatus && prevState !== nextState) {
            var _action = prevState.doc && !nextState.doc ? 'signout' : !prevState.doc && nextState.doc ? 'signin' : undefined;
            handleAuthStatus({ action: _action, doc: nextState.doc, fetchStatus: nextState.fetchStatus }, auth$$1, nextProps);
          }
        }
      }, {
        key: 'render',
        value: function render() {
          var _context$firebase = this.context.firebase,
              auth$$1 = _context$firebase.auth,
              firestore$$1 = _context$firebase.firestore,
              messaging$$1 = _context$firebase.messaging,
              storage$$1 = _context$firebase.storage;
          var _state = this.state,
              fetchStatus = _state.fetchStatus,
              doc = _state.doc;

          var props = {
            auth: auth$$1,
            authFetchStatus: fetchStatus,
            authUserDoc: doc,
            firestore: firestore$$1,
            messaging: messaging$$1,
            storage: storage$$1
          };
          if (this._loaded && fetchStatus === FetchStatus.LOADING) {
            return React__default.createElement(WrappedComponent, _extends({}, this.props, props));
          }
          switch (fetchStatus) {
            case FetchStatus.LOADED:
            case FetchStatus.FAILED:
              {
                return React__default.createElement(WrappedComponent, _extends({}, this.props, props));
              }
            default:
              return WrappedLoadingComponent ? React__default.createElement(WrappedLoadingComponent, _extends({}, this.props, props)) : null;
          }
        }
      }]);
      return _class;
    }(React.Component), _class.displayName = 'ConnectAuth', _class.WrappedComponent = WrappedComponent, _class.contextTypes = {
      firebase: propTypes.object.isRequired
    }, _temp;
  };
};

var Provider = function (_Component) {
  inherits(Provider, _Component);

  function Provider() {
    classCallCheck(this, Provider);
    return possibleConstructorReturn(this, (Provider.__proto__ || Object.getPrototypeOf(Provider)).apply(this, arguments));
  }

  createClass(Provider, [{
    key: 'getChildContext',
    value: function getChildContext() {
      var _props$store = this.props.store,
          app = _props$store.app,
          select = _props$store.select,
          selectAuth = _props$store.selectAuth,
          selectStorage = _props$store.selectStorage,
          store = _props$store.store;

      return {
        firebase: {
          app: app,
          auth: firebase.auth(app),
          firestore: firebase.firestore(app),
          messaging: firebase.messaging(app),
          select: select,
          selectAuth: selectAuth,
          selectStorage: selectStorage,
          storage: firebase.storage(app),
          store: store
        }
      };
    }
  }, {
    key: 'render',
    value: function render() {
      return this.props.children;
    }
  }]);
  return Provider;
}(React.Component);

Provider.childContextTypes = {
  firebase: propTypes.any
};

/** Detect free variable `global` from Node.js. */
var freeGlobal = typeof global == 'object' && global && global.Object === Object && global;

/** Detect free variable `self`. */
var freeSelf = typeof self == 'object' && self && self.Object === Object && self;

/** Used as a reference to the global object. */
var root = freeGlobal || freeSelf || Function('return this')();

/** Built-in value references. */
var Symbol$1 = root.Symbol;

/** Used for built-in method references. */
var objectProto$1 = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty$1 = objectProto$1.hasOwnProperty;

/**
 * Used to resolve the
 * [`toStringTag`](http://ecma-international.org/ecma-262/7.0/#sec-object.prototype.tostring)
 * of values.
 */
var nativeObjectToString = objectProto$1.toString;

/** Built-in value references. */
var symToStringTag$1 = Symbol$1 ? Symbol$1.toStringTag : undefined;

/**
 * A specialized version of `baseGetTag` which ignores `Symbol.toStringTag` values.
 *
 * @private
 * @param {*} value The value to query.
 * @returns {string} Returns the raw `toStringTag`.
 */
function getRawTag(value) {
  var isOwn = hasOwnProperty$1.call(value, symToStringTag$1),
      tag = value[symToStringTag$1];

  try {
    value[symToStringTag$1] = undefined;
    var unmasked = true;
  } catch (e) {}

  var result = nativeObjectToString.call(value);
  if (unmasked) {
    if (isOwn) {
      value[symToStringTag$1] = tag;
    } else {
      delete value[symToStringTag$1];
    }
  }
  return result;
}

/** Used for built-in method references. */
var objectProto$2 = Object.prototype;

/**
 * Used to resolve the
 * [`toStringTag`](http://ecma-international.org/ecma-262/7.0/#sec-object.prototype.tostring)
 * of values.
 */
var nativeObjectToString$1 = objectProto$2.toString;

/**
 * Converts `value` to a string using `Object.prototype.toString`.
 *
 * @private
 * @param {*} value The value to convert.
 * @returns {string} Returns the converted string.
 */
function objectToString(value) {
  return nativeObjectToString$1.call(value);
}

/** `Object#toString` result references. */
var nullTag = '[object Null]';
var undefinedTag = '[object Undefined]';

/** Built-in value references. */
var symToStringTag = Symbol$1 ? Symbol$1.toStringTag : undefined;

/**
 * The base implementation of `getTag` without fallbacks for buggy environments.
 *
 * @private
 * @param {*} value The value to query.
 * @returns {string} Returns the `toStringTag`.
 */
function baseGetTag(value) {
  if (value == null) {
    return value === undefined ? undefinedTag : nullTag;
  }
  return (symToStringTag && symToStringTag in Object(value))
    ? getRawTag(value)
    : objectToString(value);
}

/**
 * Creates a unary function that invokes `func` with its argument transformed.
 *
 * @private
 * @param {Function} func The function to wrap.
 * @param {Function} transform The argument transform.
 * @returns {Function} Returns the new function.
 */
function overArg(func, transform) {
  return function(arg) {
    return func(transform(arg));
  };
}

/** Built-in value references. */
var getPrototype = overArg(Object.getPrototypeOf, Object);

/**
 * Checks if `value` is object-like. A value is object-like if it's not `null`
 * and has a `typeof` result of "object".
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is object-like, else `false`.
 * @example
 *
 * _.isObjectLike({});
 * // => true
 *
 * _.isObjectLike([1, 2, 3]);
 * // => true
 *
 * _.isObjectLike(_.noop);
 * // => false
 *
 * _.isObjectLike(null);
 * // => false
 */
function isObjectLike(value) {
  return value != null && typeof value == 'object';
}

/** `Object#toString` result references. */
var objectTag = '[object Object]';

/** Used for built-in method references. */
var funcProto = Function.prototype;
var objectProto = Object.prototype;

/** Used to resolve the decompiled source of functions. */
var funcToString = funcProto.toString;

/** Used to check objects for own properties. */
var hasOwnProperty = objectProto.hasOwnProperty;

/** Used to infer the `Object` constructor. */
var objectCtorString = funcToString.call(Object);

/**
 * Checks if `value` is a plain object, that is, an object created by the
 * `Object` constructor or one with a `[[Prototype]]` of `null`.
 *
 * @static
 * @memberOf _
 * @since 0.8.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a plain object, else `false`.
 * @example
 *
 * function Foo() {
 *   this.a = 1;
 * }
 *
 * _.isPlainObject(new Foo);
 * // => false
 *
 * _.isPlainObject([1, 2, 3]);
 * // => false
 *
 * _.isPlainObject({ 'x': 0, 'y': 0 });
 * // => true
 *
 * _.isPlainObject(Object.create(null));
 * // => true
 */
function isPlainObject(value) {
  if (!isObjectLike(value) || baseGetTag(value) != objectTag) {
    return false;
  }
  var proto = getPrototype(value);
  if (proto === null) {
    return true;
  }
  var Ctor = hasOwnProperty.call(proto, 'constructor') && proto.constructor;
  return typeof Ctor == 'function' && Ctor instanceof Ctor &&
    funcToString.call(Ctor) == objectCtorString;
}

var commonjsGlobal = typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};



function unwrapExports (x) {
	return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x['default'] : x;
}

function createCommonjsModule(fn, module) {
	return module = { exports: {} }, fn(module, module.exports), module.exports;
}

var ponyfill = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", {
	value: true
});
exports['default'] = symbolObservablePonyfill;
function symbolObservablePonyfill(root) {
	var result;
	var _Symbol = root.Symbol;

	if (typeof _Symbol === 'function') {
		if (_Symbol.observable) {
			result = _Symbol.observable;
		} else {
			result = _Symbol('observable');
			_Symbol.observable = result;
		}
	} else {
		result = '@@observable';
	}

	return result;
}
});

unwrapExports(ponyfill);

var lib = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", {
  value: true
});



var _ponyfill2 = _interopRequireDefault(ponyfill);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var root; /* global window */


if (typeof self !== 'undefined') {
  root = self;
} else if (typeof window !== 'undefined') {
  root = window;
} else if (typeof commonjsGlobal !== 'undefined') {
  root = commonjsGlobal;
} else {
  root = module;
}

var result = (0, _ponyfill2['default'])(root);
exports['default'] = result;
});

unwrapExports(lib);

var symbolObservable = lib;

/**
 * These are private action types reserved by Redux.
 * For any unknown actions, you must return the current state.
 * If the current state is undefined, you must return the initial state.
 * Do not reference these action types directly in your code.
 */
var ActionTypes = {
  INIT: '@@redux/INIT'

  /**
   * Creates a Redux store that holds the state tree.
   * The only way to change the data in the store is to call `dispatch()` on it.
   *
   * There should only be a single store in your app. To specify how different
   * parts of the state tree respond to actions, you may combine several reducers
   * into a single reducer function by using `combineReducers`.
   *
   * @param {Function} reducer A function that returns the next state tree, given
   * the current state tree and the action to handle.
   *
   * @param {any} [preloadedState] The initial state. You may optionally specify it
   * to hydrate the state from the server in universal apps, or to restore a
   * previously serialized user session.
   * If you use `combineReducers` to produce the root reducer function, this must be
   * an object with the same shape as `combineReducers` keys.
   *
   * @param {Function} [enhancer] The store enhancer. You may optionally specify it
   * to enhance the store with third-party capabilities such as middleware,
   * time travel, persistence, etc. The only store enhancer that ships with Redux
   * is `applyMiddleware()`.
   *
   * @returns {Store} A Redux store that lets you read the state, dispatch actions
   * and subscribe to changes.
   */
};function createStore(reducer, preloadedState, enhancer) {
  var _ref2;

  if (typeof preloadedState === 'function' && typeof enhancer === 'undefined') {
    enhancer = preloadedState;
    preloadedState = undefined;
  }

  if (typeof enhancer !== 'undefined') {
    if (typeof enhancer !== 'function') {
      throw new Error('Expected the enhancer to be a function.');
    }

    return enhancer(createStore)(reducer, preloadedState);
  }

  if (typeof reducer !== 'function') {
    throw new Error('Expected the reducer to be a function.');
  }

  var currentReducer = reducer;
  var currentState = preloadedState;
  var currentListeners = [];
  var nextListeners = currentListeners;
  var isDispatching = false;

  function ensureCanMutateNextListeners() {
    if (nextListeners === currentListeners) {
      nextListeners = currentListeners.slice();
    }
  }

  /**
   * Reads the state tree managed by the store.
   *
   * @returns {any} The current state tree of your application.
   */
  function getState() {
    return currentState;
  }

  /**
   * Adds a change listener. It will be called any time an action is dispatched,
   * and some part of the state tree may potentially have changed. You may then
   * call `getState()` to read the current state tree inside the callback.
   *
   * You may call `dispatch()` from a change listener, with the following
   * caveats:
   *
   * 1. The subscriptions are snapshotted just before every `dispatch()` call.
   * If you subscribe or unsubscribe while the listeners are being invoked, this
   * will not have any effect on the `dispatch()` that is currently in progress.
   * However, the next `dispatch()` call, whether nested or not, will use a more
   * recent snapshot of the subscription list.
   *
   * 2. The listener should not expect to see all state changes, as the state
   * might have been updated multiple times during a nested `dispatch()` before
   * the listener is called. It is, however, guaranteed that all subscribers
   * registered before the `dispatch()` started will be called with the latest
   * state by the time it exits.
   *
   * @param {Function} listener A callback to be invoked on every dispatch.
   * @returns {Function} A function to remove this change listener.
   */
  function subscribe(listener) {
    if (typeof listener !== 'function') {
      throw new Error('Expected listener to be a function.');
    }

    var isSubscribed = true;

    ensureCanMutateNextListeners();
    nextListeners.push(listener);

    return function unsubscribe() {
      if (!isSubscribed) {
        return;
      }

      isSubscribed = false;

      ensureCanMutateNextListeners();
      var index = nextListeners.indexOf(listener);
      nextListeners.splice(index, 1);
    };
  }

  /**
   * Dispatches an action. It is the only way to trigger a state change.
   *
   * The `reducer` function, used to create the store, will be called with the
   * current state tree and the given `action`. Its return value will
   * be considered the **next** state of the tree, and the change listeners
   * will be notified.
   *
   * The base implementation only supports plain object actions. If you want to
   * dispatch a Promise, an Observable, a thunk, or something else, you need to
   * wrap your store creating function into the corresponding middleware. For
   * example, see the documentation for the `redux-thunk` package. Even the
   * middleware will eventually dispatch plain object actions using this method.
   *
   * @param {Object} action A plain object representing “what changed”. It is
   * a good idea to keep actions serializable so you can record and replay user
   * sessions, or use the time travelling `redux-devtools`. An action must have
   * a `type` property which may not be `undefined`. It is a good idea to use
   * string constants for action types.
   *
   * @returns {Object} For convenience, the same action object you dispatched.
   *
   * Note that, if you use a custom middleware, it may wrap `dispatch()` to
   * return something else (for example, a Promise you can await).
   */
  function dispatch(action) {
    if (!isPlainObject(action)) {
      throw new Error('Actions must be plain objects. ' + 'Use custom middleware for async actions.');
    }

    if (typeof action.type === 'undefined') {
      throw new Error('Actions may not have an undefined "type" property. ' + 'Have you misspelled a constant?');
    }

    if (isDispatching) {
      throw new Error('Reducers may not dispatch actions.');
    }

    try {
      isDispatching = true;
      currentState = currentReducer(currentState, action);
    } finally {
      isDispatching = false;
    }

    var listeners = currentListeners = nextListeners;
    for (var i = 0; i < listeners.length; i++) {
      var listener = listeners[i];
      listener();
    }

    return action;
  }

  /**
   * Replaces the reducer currently used by the store to calculate the state.
   *
   * You might need this if your app implements code splitting and you want to
   * load some of the reducers dynamically. You might also need this if you
   * implement a hot reloading mechanism for Redux.
   *
   * @param {Function} nextReducer The reducer for the store to use instead.
   * @returns {void}
   */
  function replaceReducer(nextReducer) {
    if (typeof nextReducer !== 'function') {
      throw new Error('Expected the nextReducer to be a function.');
    }

    currentReducer = nextReducer;
    dispatch({ type: ActionTypes.INIT });
  }

  /**
   * Interoperability point for observable/reactive libraries.
   * @returns {observable} A minimal observable of state changes.
   * For more information, see the observable proposal:
   * https://github.com/tc39/proposal-observable
   */
  function observable() {
    var _ref;

    var outerSubscribe = subscribe;
    return _ref = {
      /**
       * The minimal observable subscription method.
       * @param {Object} observer Any object that can be used as an observer.
       * The observer object should have a `next` method.
       * @returns {subscription} An object with an `unsubscribe` method that can
       * be used to unsubscribe the observable from the store, and prevent further
       * emission of values from the observable.
       */
      subscribe: function subscribe(observer) {
        if (typeof observer !== 'object') {
          throw new TypeError('Expected the observer to be an object.');
        }

        function observeState() {
          if (observer.next) {
            observer.next(getState());
          }
        }

        observeState();
        var unsubscribe = outerSubscribe(observeState);
        return { unsubscribe: unsubscribe };
      }
    }, _ref[symbolObservable] = function () {
      return this;
    }, _ref;
  }

  // When a store is created, an "INIT" action is dispatched so that every
  // reducer returns their initial state. This effectively populates
  // the initial state tree.
  dispatch({ type: ActionTypes.INIT });

  return _ref2 = {
    dispatch: dispatch,
    subscribe: subscribe,
    getState: getState,
    replaceReducer: replaceReducer
  }, _ref2[symbolObservable] = observable, _ref2;
}

/**
 * Prints a warning in the console if it exists.
 *
 * @param {String} message The warning message.
 * @returns {void}
 */
function warning(message) {
  /* eslint-disable no-console */
  if (typeof console !== 'undefined' && typeof console.error === 'function') {
    console.error(message);
  }
  /* eslint-enable no-console */
  try {
    // This error was thrown as a convenience so that if you enable
    // "break on all exceptions" in your console,
    // it would pause the execution at this line.
    throw new Error(message);
    /* eslint-disable no-empty */
  } catch (e) {}
  /* eslint-enable no-empty */
}

function getUndefinedStateErrorMessage(key, action) {
  var actionType = action && action.type;
  var actionName = actionType && '"' + actionType.toString() + '"' || 'an action';

  return 'Given action ' + actionName + ', reducer "' + key + '" returned undefined. ' + 'To ignore an action, you must explicitly return the previous state. ' + 'If you want this reducer to hold no value, you can return null instead of undefined.';
}

function getUnexpectedStateShapeWarningMessage(inputState, reducers, action, unexpectedKeyCache) {
  var reducerKeys = Object.keys(reducers);
  var argumentName = action && action.type === ActionTypes.INIT ? 'preloadedState argument passed to createStore' : 'previous state received by the reducer';

  if (reducerKeys.length === 0) {
    return 'Store does not have a valid reducer. Make sure the argument passed ' + 'to combineReducers is an object whose values are reducers.';
  }

  if (!isPlainObject(inputState)) {
    return 'The ' + argumentName + ' has unexpected type of "' + {}.toString.call(inputState).match(/\s([a-z|A-Z]+)/)[1] + '". Expected argument to be an object with the following ' + ('keys: "' + reducerKeys.join('", "') + '"');
  }

  var unexpectedKeys = Object.keys(inputState).filter(function (key) {
    return !reducers.hasOwnProperty(key) && !unexpectedKeyCache[key];
  });

  unexpectedKeys.forEach(function (key) {
    unexpectedKeyCache[key] = true;
  });

  if (unexpectedKeys.length > 0) {
    return 'Unexpected ' + (unexpectedKeys.length > 1 ? 'keys' : 'key') + ' ' + ('"' + unexpectedKeys.join('", "') + '" found in ' + argumentName + '. ') + 'Expected to find one of the known reducer keys instead: ' + ('"' + reducerKeys.join('", "') + '". Unexpected keys will be ignored.');
  }
}

function assertReducerShape(reducers) {
  Object.keys(reducers).forEach(function (key) {
    var reducer = reducers[key];
    var initialState = reducer(undefined, { type: ActionTypes.INIT });

    if (typeof initialState === 'undefined') {
      throw new Error('Reducer "' + key + '" returned undefined during initialization. ' + 'If the state passed to the reducer is undefined, you must ' + 'explicitly return the initial state. The initial state may ' + 'not be undefined. If you don\'t want to set a value for this reducer, ' + 'you can use null instead of undefined.');
    }

    var type = '@@redux/PROBE_UNKNOWN_ACTION_' + Math.random().toString(36).substring(7).split('').join('.');
    if (typeof reducer(undefined, { type: type }) === 'undefined') {
      throw new Error('Reducer "' + key + '" returned undefined when probed with a random type. ' + ('Don\'t try to handle ' + ActionTypes.INIT + ' or other actions in "redux/*" ') + 'namespace. They are considered private. Instead, you must return the ' + 'current state for any unknown actions, unless it is undefined, ' + 'in which case you must return the initial state, regardless of the ' + 'action type. The initial state may not be undefined, but can be null.');
    }
  });
}

/**
 * Turns an object whose values are different reducer functions, into a single
 * reducer function. It will call every child reducer, and gather their results
 * into a single state object, whose keys correspond to the keys of the passed
 * reducer functions.
 *
 * @param {Object} reducers An object whose values correspond to different
 * reducer functions that need to be combined into one. One handy way to obtain
 * it is to use ES6 `import * as reducers` syntax. The reducers may never return
 * undefined for any action. Instead, they should return their initial state
 * if the state passed to them was undefined, and the current state for any
 * unrecognized action.
 *
 * @returns {Function} A reducer function that invokes every reducer inside the
 * passed object, and builds a state object with the same shape.
 */
function combineReducers(reducers) {
  var reducerKeys = Object.keys(reducers);
  var finalReducers = {};
  for (var i = 0; i < reducerKeys.length; i++) {
    var key = reducerKeys[i];

    if (process.env.NODE_ENV !== 'production') {
      if (typeof reducers[key] === 'undefined') {
        warning('No reducer provided for key "' + key + '"');
      }
    }

    if (typeof reducers[key] === 'function') {
      finalReducers[key] = reducers[key];
    }
  }
  var finalReducerKeys = Object.keys(finalReducers);

  var unexpectedKeyCache = void 0;
  if (process.env.NODE_ENV !== 'production') {
    unexpectedKeyCache = {};
  }

  var shapeAssertionError = void 0;
  try {
    assertReducerShape(finalReducers);
  } catch (e) {
    shapeAssertionError = e;
  }

  return function combination() {
    var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    var action = arguments[1];

    if (shapeAssertionError) {
      throw shapeAssertionError;
    }

    if (process.env.NODE_ENV !== 'production') {
      var warningMessage = getUnexpectedStateShapeWarningMessage(state, finalReducers, action, unexpectedKeyCache);
      if (warningMessage) {
        warning(warningMessage);
      }
    }

    var hasChanged = false;
    var nextState = {};
    for (var _i = 0; _i < finalReducerKeys.length; _i++) {
      var _key = finalReducerKeys[_i];
      var reducer = finalReducers[_key];
      var previousStateForKey = state[_key];
      var nextStateForKey = reducer(previousStateForKey, action);
      if (typeof nextStateForKey === 'undefined') {
        var errorMessage = getUndefinedStateErrorMessage(_key, action);
        throw new Error(errorMessage);
      }
      nextState[_key] = nextStateForKey;
      hasChanged = hasChanged || nextStateForKey !== previousStateForKey;
    }
    return hasChanged ? nextState : state;
  };
}

/**
 * Composes single-argument functions from right to left. The rightmost
 * function can take multiple arguments as it provides the signature for
 * the resulting composite function.
 *
 * @param {...Function} funcs The functions to compose.
 * @returns {Function} A function obtained by composing the argument functions
 * from right to left. For example, compose(f, g, h) is identical to doing
 * (...args) => f(g(h(...args))).
 */

function compose() {
  for (var _len = arguments.length, funcs = Array(_len), _key = 0; _key < _len; _key++) {
    funcs[_key] = arguments[_key];
  }

  if (funcs.length === 0) {
    return function (arg) {
      return arg;
    };
  }

  if (funcs.length === 1) {
    return funcs[0];
  }

  return funcs.reduce(function (a, b) {
    return function () {
      return a(b.apply(undefined, arguments));
    };
  });
}

var _extends$1 = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

/**
 * Creates a store enhancer that applies middleware to the dispatch method
 * of the Redux store. This is handy for a variety of tasks, such as expressing
 * asynchronous actions in a concise manner, or logging every action payload.
 *
 * See `redux-thunk` package as an example of the Redux middleware.
 *
 * Because middleware is potentially asynchronous, this should be the first
 * store enhancer in the composition chain.
 *
 * Note that each middleware will be given the `dispatch` and `getState` functions
 * as named arguments.
 *
 * @param {...Function} middlewares The middleware chain to be applied.
 * @returns {Function} A store enhancer applying the middleware.
 */
function applyMiddleware() {
  for (var _len = arguments.length, middlewares = Array(_len), _key = 0; _key < _len; _key++) {
    middlewares[_key] = arguments[_key];
  }

  return function (createStore) {
    return function (reducer, preloadedState, enhancer) {
      var store = createStore(reducer, preloadedState, enhancer);
      var _dispatch = store.dispatch;
      var chain = [];

      var middlewareAPI = {
        getState: store.getState,
        dispatch: function dispatch(action) {
          return _dispatch(action);
        }
      };
      chain = middlewares.map(function (middleware) {
        return middleware(middlewareAPI);
      });
      _dispatch = compose.apply(undefined, chain)(store.dispatch);

      return _extends$1({}, store, {
        dispatch: _dispatch
      });
    };
  };
}

/*
* This is a dummy function to check if the function name has been altered by minification.
* If the function has been minified and NODE_ENV !== 'production', warn the user.
*/
function isCrushed() {}

if (process.env.NODE_ENV !== 'production' && typeof isCrushed.name === 'string' && isCrushed.name !== 'isCrushed') {
  warning('You are currently using minified code outside of NODE_ENV === \'production\'. ' + 'This means that you are running a slower development build of Redux. ' + 'You can use loose-envify (https://github.com/zertosh/loose-envify) for browserify ' + 'or DefinePlugin for webpack (http://stackoverflow.com/questions/30030031) ' + 'to ensure you have the correct code for your production build.');
}

var emptyArray = [];

// $FlowFixMe Undocumented key/value

var pathToString = function pathToString(path) {
  return path.segments.join('/');
};

var filterToString = function filterToString(filter) {
  var field = filter.field,
      op = filter.op,
      value = filter.value;

  return '' + pathToString(field) + op.name + value.toString();
};

var getQueryId = function getQueryId(query) {
  // $FlowFixMe Undocumented key/value
  if (query.id && query.id === query.path) {
    // $FlowFixMe Undocumented key/value
    return query.id;
  }

  if (query.path && typeof query.path === 'string') {
    // $FlowFixMe Undocumented key/value
    return query.path;
  }

  if (query._query) {
    // $FlowFixMe Grabbing private value
    var _query$_query = query._query,
        filters = _query$_query.filters,
        limit = _query$_query.limit,
        path = _query$_query.path;

    var filterString = filters.map(filterToString).join('|');
    return '' + pathToString(path) + (filterString ? ':' + filterString : '') + (limit ? ':' + limit : '');
  }

  throw new Error('Unknown query type');
};

var getQueryPath = function getQueryPath(query) {
  if (query.path) {
    // $FlowFixMe Undocumented key/value
    return query.path;
  }

  if (query._query) {
    // $FlowFixMe Grabbing private value
    var path = query._query.path;

    return pathToString(path);
  }

  throw new Error('Unknown query type');
};

var getCollectionQueryPath = function getCollectionQueryPath(query) {
  var fullPath = getQueryPath(query);
  var pathParts = fullPath.split('/');
  return pathParts.length % 2 ? fullPath : fullPath.replace(/(\/[^/]+)$/, '');
};

var _getValueFromFieldPath = function _getValueFromFieldPath(doc, fieldPath) {
  var value = doc;
  // $FlowFixMe Undocumented key/value
  for (var i = 0; i < fieldPath.segments.length; i++) {
    // $FlowFixMe Undocumented key/value
    var segment = fieldPath.segments[i];
    value = value && (typeof value === 'undefined' ? 'undefined' : _typeof(value)) === 'object' ? value[segment] : undefined;
    if ((typeof value === 'undefined' ? 'undefined' : _typeof(value)) === undefined) {
      return undefined;
    }
  }
  return value;
};

var getDocumentIdsForQuery = function getDocumentIdsForQuery(query, state) {
  var collectionPath = getCollectionQueryPath(query);
  var queryPath = getQueryPath(query);
  var pathParts = queryPath.split('/');
  var documents = state.collections[collectionPath];
  if (!(pathParts.length % 2)) {
    var documentId = pathParts[pathParts.length - 1];
    return Object.keys(documents).indexOf(documentId) >= 0 ? [documentId] : [];
  }

  if (query._query) {
    // $FlowFixMe Undocumented key/value
    var _query$_query2 = query._query,
        filters = _query$_query2.filters,
        limit = _query$_query2.limit,
        orderBy = _query$_query2.orderBy;

    var docs = Object.values(documents).filter(function (doc) {
      return filters.every(function (_ref) {
        var field = _ref.field,
            op = _ref.op,
            value = _ref.value;

        var docValue = _getValueFromFieldPath(doc, field);
        var internalValue = value.internalValue;

        var normValue = (typeof internalValue === 'undefined' ? 'undefined' : _typeof(internalValue)) === 'object' ? internalValue.seconds ? new Date(internalValue.seconds) : internalValue : internalValue;
        switch (op.name) {
          case '<':
            return docValue < normValue;
          case '<=':
            return docValue <= normValue;
          case '==':
            return docValue == normValue;
          case '>':
            return docValue > normValue;
          case '>=':
            return docValue >= normValue;
          default:
            return true;
        }
      });
    });

    if (orderBy && orderBy.length > 0) {
      orderBy.forEach(function (order) {
        var dir = order.dir.name,
            field = order.field;

        docs = docs.sort(function (a, b) {
          var aValue = _getValueFromFieldPath(a, field);
          var bValue = _getValueFromFieldPath(b, field);
          if (!aValue || !bValue) {
            return 0;
          }
          if (typeof aValue === 'string' && typeof bValue === 'string') {
            return dir === 'asc' ? aValue.localeCompare(bValue) : bValue.localeCompare(aValue);
          }
          if (aValue instanceof Date && bValue instanceof Date) {
            return dir === 'asc' ? aValue.valueOf() - bValue.valueOf() : bValue.valueOf() - aValue.valueOf();
          }
          if (typeof aValue === 'number' && typeof bValue === 'number') {
            return dir === 'asc' ? aValue - bValue : bValue - aValue;
          }
          return 0;
        });
      });
    }

    return docs.map(function (doc) {
      return (typeof doc === 'undefined' ? 'undefined' : _typeof(doc)) === 'object' && doc && typeof doc.id === 'string' ? doc.id : undefined;
    }).filter(Boolean).slice(0, limit || Infinity);
  }
  return emptyArray;
};

var RequestAction = {
  REQUEST: 'request',
  SUCCESS: 'success',
  FAILURE: 'failure'
};

var NAMESPACE = 'firestore';

var createActionType = function createActionType(action) {
  return NAMESPACE + '/' + action;
};

var createRequestActionTypes = function createRequestActionTypes(request) {
  return Object.keys(RequestAction).reduce(function (memo, key) {
    memo[key] = createActionType(request + '/' + key);
    return memo;
  }, { REQUEST: '', SUCCESS: '', FAILURE: '' });
};

var COLLECTIONS = {
  MODIFY: createActionType('collections/MODIFY'),
  MODIFY_ONE: createActionType('collections/MODIFY_ONE'),
  REMOVE: createActionType('collections/REMOVE')
};

var QUERIES = _extends({}, createRequestActionTypes('queries'), {
  ADD: createActionType('queries/ADD'),
  REMOVE: createActionType('queries/REMOVE')
});

var onIdle = function onIdle(fn) {
  return window.requestIdleCallback ? window.requestIdleCallback(fn) : setTimeout(fn, 1);
};

var _handleReceiveSnapshot = function _handleReceiveSnapshot(dispatch, query, queryId) {
  return function (snapshot) {
    var actions = [];
    if (snapshot.docChanges) {
      actions.push({ type: COLLECTIONS.MODIFY, payload: snapshot, meta: { query: query } });
    } else {
      actions.push({ type: COLLECTIONS.MODIFY_ONE, payload: snapshot, meta: { query: query } });
    }
    actions.push({ type: QUERIES.SUCCESS, payload: snapshot, meta: { queryId: queryId } });
    dispatch(actions);
  };
};

var addQuery = function addQuery(query) {
  var queryIdPrefix = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';
  return function (dispatch, getState) {
    var state = getState();
    var queries = state.queries;

    var queryId = '' + queryIdPrefix + getQueryId(query);
    var collectionPath = '' + queryIdPrefix + getCollectionQueryPath(query);

    var meta = { queryId: queryId };

    if (queryId !== collectionPath && collectionPath in queries) {
      var documentIds = getDocumentIdsForQuery(query, state);
      return Promise.resolve(dispatch({ type: QUERIES.ADD, payload: documentIds, meta: meta }));
    }

    if (queryId in queries) {
      return Promise.resolve();
    }

    dispatch({ type: QUERIES.REQUEST, payload: query, meta: meta });

    return query.get().then(_handleReceiveSnapshot(dispatch, query, queryId)).catch(function (error) {
      dispatch({ error: true, type: QUERIES.FAILURE, payload: error, meta: meta });
    });
  };
};

var removeQuery = function removeQuery(query) {
  var queryIdPrefix = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';
  return {
    type: QUERIES.REMOVE,
    payload: query,
    meta: { queryId: '' + queryIdPrefix + getQueryId(query) }
  };
};

var LISTENERS = {
  ADD: createActionType('listeners/ADD'),
  REMOVE: createActionType('listeners/REMOVE')
};

var addListener = function addListener(query) {
  var queryIdPrefix = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';
  return function (dispatch, getState) {
    var _getState = getState(),
        listeners = _getState.listeners;

    var queryId = '' + queryIdPrefix + getQueryId(query);
    var collectionPath = '' + queryIdPrefix + getCollectionQueryPath(query);

    if (queryId in listeners || collectionPath in listeners) {
      return Promise.resolve();
    }

    return new Promise(function (resolve) {
      onIdle(function () {
        var unsubscribe = query.onSnapshot(_handleReceiveSnapshot(dispatch, query, queryId));
        resolve(dispatch({ type: LISTENERS.ADD, payload: unsubscribe, meta: { queryId: queryId } }));
      });
    });
  };
};

var removeListener = function removeListener(query) {
  var queryIdPrefix = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';
  return function (dispatch, getState) {
    var queryId = '' + queryIdPrefix + getQueryId(query);

    var _getState2 = getState(),
        listeners = _getState2.listeners;

    if (listeners[queryId]) {
      listeners[queryId].unsubscribe();
      return Promise.resolve(dispatch({
        type: LISTENERS.REMOVE,
        meta: { queryId: queryId }
      }));
    }

    return Promise.resolve();
  };
};

var _authQueryPrefix = 'auth|';
var AUTH = {
  CHANGE: createActionType('auth/CHANGE')
};

var setUser = function setUser(currentUser, userCollection) {
  return function (dispatch, getState, _ref) {
    var firestore$$1 = _ref.firestore;

    var actions = [];
    if (currentUser && userCollection) {
      var query = firestore$$1.doc(userCollection + '/' + currentUser.uid);
      actions.push(addQuery(query, _authQueryPrefix));
      actions.push(addListener(query, _authQueryPrefix));
    }
    actions.push({ type: AUTH.CHANGE, payload: currentUser });
    return Promise.resolve(dispatch(actions));
  };
};

var unsetUser = function unsetUser(uid, userCollection) {
  return function (dispatch, getState, _ref2) {
    var firestore$$1 = _ref2.firestore;

    var actions = [];
    if (uid) {
      if (userCollection) {
        var query = firestore$$1.doc(userCollection + '/' + uid);
        actions.push(removeQuery(query, _authQueryPrefix));
        actions.push(removeListener(query, _authQueryPrefix));
        actions.push({ type: COLLECTIONS.REMOVE, payload: { id: uid }, meta: { query: query } });
      }
      actions.push({ type: AUTH.CHANGE });
      dispatch(actions);
    }
    return Promise.resolve();
  };
};

var STORAGE = {
  URL: createRequestActionTypes('storage/downloadUrl'),
  METADATA: createRequestActionTypes('storage/metadata')
};

var getStorageDownloadUrl = function getStorageDownloadUrl(reference) {
  return function (dispatch, getState) {
    var meta = { reference: reference };
    var state = getState();
    var ref = state.storage[reference.fullPath];
    if (ref && ref.downloadUrl) {
      return Promise.resolve(ref);
    }

    dispatch({ type: STORAGE.URL.REQUEST, meta: meta });
    return reference.getDownloadURL().then(function (url) {
      return dispatch({ type: STORAGE.URL.SUCCESS, payload: url, meta: meta });
    }).catch(function (error) {
      dispatch({ error: true, type: STORAGE.URL.FAILURE, payload: error, meta: meta });
      throw error;
    });
  };
};

var getStorageMetadata = function getStorageMetadata(reference) {
  return function (dispatch, getState) {
    var meta = { reference: reference };
    var state = getState();
    var ref = state.storage[reference.fullPath];
    if (ref && ref.metadata) {
      return Promise.resolve(ref);
    }

    dispatch({ type: STORAGE.METADATA.REQUEST, meta: meta });
    return reference.getMetadata().then(function (data) {
      return dispatch({ type: STORAGE.METADATA.SUCCESS, payload: data, meta: meta });
    }).catch(function (error) {
      dispatch({ error: true, type: STORAGE.METADATA.FAILURE, payload: error, meta: meta });
      throw error;
    });
  };
};

var defaultState = {};

function reducer$1() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defaultState;
  var action = arguments[1];

  switch (action.type) {
    case AUTH.CHANGE:
      return action.payload ? _extends({}, state, action.payload.toJSON()) : defaultState;

    default:
      return state;
  }
}

var defaultState$1 = {};
var emptyObject$1 = {};

function reducer$2() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defaultState$1;
  var action = arguments[1];

  switch (action.type) {
    case COLLECTIONS.MODIFY_ONE:
      {
        var meta = action.meta,
            payload = action.payload;

        if (!(payload && payload.id)) {
          return state;
        }

        var path = getCollectionQueryPath(meta.query);
        return _extends({}, state, defineProperty({}, path, _extends({}, state[path], defineProperty({}, payload.id, _extends({ id: payload.id }, payload.data())))));
      }

    case COLLECTIONS.MODIFY:
      {
        var _meta = action.meta,
            _payload = action.payload;

        if (!_meta || !(_payload && _payload.docChanges)) {
          return state;
        }

        var _path = getCollectionQueryPath(_meta.query);

        // $FlowFixMe
        var newPathState = _payload.docChanges.reduce(function (newState, change) {
          var doc = change.doc,
              changeType = change.type;

          var oldData = newState[doc.id] || emptyObject$1;
          switch (changeType) {
            case 'added':
              {
                if (!(doc.id in newState)) {
                  newState[doc.id] = _extends({
                    id: doc.id
                  }, change.doc.data());
                }
                break;
              }

            case 'modified':
              newState[doc.id] = _extends({}, oldData, {
                id: doc.id
              }, change.doc.data());
              break;

            case 'removed':
              delete newState[doc.id];
              break;
            // no default
          }
          return newState;
        }, state[_path] || {});
        return _extends({}, state, defineProperty({}, _path, newPathState));
      }

    case COLLECTIONS.REMOVE:
      {
        var _meta2 = action.meta,
            _id = action.payload.id;

        var _path2 = getCollectionQueryPath(_meta2.query);
        var pathDocs = _extends({}, state[_path2]);
        delete pathDocs[_id];
        return _extends({}, state, defineProperty({}, _path2, pathDocs));
      }

    default:
      return state;
  }
}

var defaultState$2 = {};

function reducer$3() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defaultState$2;
  var action = arguments[1];

  switch (action.type) {
    case LISTENERS.ADD:
      {
        var _queryId = action.meta.queryId,
            payload = action.payload;

        return _extends({}, state, defineProperty({}, _queryId, {
          unsubscribe: payload
        }));
      }

    case LISTENERS.REMOVE:
      {
        var _queryId2 = action.meta.queryId;

        var newState = _extends({}, state);
        delete newState[_queryId2];
        return newState;
      }

    default:
      return state;
  }
}

var defaultState$3 = {};
var defaultQueryState = {
  documentIds: [],
  error: undefined,
  fetchStatus: FetchStatus.NONE
};

var sortChanges = function sortChanges(a, b) {
  return a.doc.newIndex - b.doc.newIndex;
};

var updateMultiple = function updateMultiple(state, payload, queryId) {
  var documentIds = payload.docChanges.sort(sortChanges).reduce(function (memo, change) {
    var doc = change.doc,
        changeType = change.type,
        newIndex = change.newIndex;

    switch (changeType) {
      case 'added':
      case 'modified':
        if (memo.indexOf(doc.id) !== -1) {
          return memo;
        }
        if (memo.length === 0) {
          return [doc.id];
        }
        memo.splice(newIndex, 0, doc.id);
        return memo;
      case 'removed':
        memo.splice(newIndex, 1);
        return memo;
      default:
        return memo;
    }
  }, [].concat(toConsumableArray(state[queryId].documentIds)));
  return _extends({}, state, defineProperty({}, queryId, _extends({}, state[queryId], {
    documentIds: documentIds,
    fetchStatus: FetchStatus.LOADED
  })));
};

var updateOne = function updateOne(state, payload, queryId) {
  return _extends({}, state, defineProperty({}, queryId, _extends({}, state[queryId], {
    documentIds: [payload.id],
    fetchStatus: FetchStatus.LOADED
  })));
};

function reducer$4() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defaultState$3;
  var action = arguments[1];

  switch (action.type) {
    case QUERIES.REQUEST:
      {
        var _queryId = action.meta.queryId;

        return _extends({}, state, defineProperty({}, _queryId, _extends({}, defaultQueryState, state[_queryId], {
          fetchStatus: FetchStatus.LOADING
        })));
      }

    case QUERIES.SUCCESS:
      {
        var _queryId2 = action.meta.queryId,
            payload = action.payload;

        if (payload.docChanges) {
          return updateMultiple(state, payload, _queryId2);
        } else {
          return updateOne(state, payload, _queryId2);
        }
      }

    case QUERIES.FAILURE:
      {
        var _queryId3 = action.meta.queryId,
            _payload = action.payload;

        return _extends({}, state, defineProperty({}, _queryId3, _extends({}, state[_queryId3], {
          error: _payload,
          fetchStatus: FetchStatus.FAILED
        })));
      }

    case QUERIES.ADD:
      {
        var _queryId4 = action.meta.queryId,
            _documentIds = action.payload;

        return _extends({}, state, defineProperty({}, _queryId4, _extends({}, state[_queryId4], {
          documentIds: _documentIds,
          fetchStatus: FetchStatus.LOADED
        })));
      }

    case QUERIES.REMOVE:
      {
        var _queryId5 = action.meta.queryId;

        var newState = _extends({}, state);
        delete newState[_queryId5];
        return newState;
      }

    default:
      return state;
  }
}

var defaultState$4 = {};

function reducer$5() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defaultState$4;
  var action = arguments[1];

  switch (action.type) {
    case STORAGE.URL.REQUEST:
      {
        var _reference = action.meta.reference;

        return _extends({}, state, defineProperty({}, _reference.fullPath, _extends({}, state[_reference.fullPath], { fetchStatus: FetchStatus.LOADING })));
      }

    case STORAGE.URL.SUCCESS:
      {
        var _reference2 = action.meta.reference,
            payload = action.payload;

        return _extends({}, state, defineProperty({}, _reference2.fullPath, { fetchStatus: FetchStatus.LOADED, downloadUrl: payload }));
      }

    case STORAGE.URL.FAILURE:
      {
        var _reference3 = action.meta.reference;

        return _extends({}, state, defineProperty({}, _reference3.fullPath, _extends({}, state[_reference3.fullPath], { fetchStatus: FetchStatus.FAILED })));
      }

    case STORAGE.METADATA.REQUEST:
      {
        var _reference4 = action.meta.reference;

        return _extends({}, state, defineProperty({}, _reference4.fullPath, _extends({}, state[_reference4.fullPath], { fetchStatus: FetchStatus.LOADING })));
      }

    case STORAGE.METADATA.SUCCESS:
      {
        var _reference5 = action.meta.reference,
            _payload = action.payload;

        return _extends({}, state, defineProperty({}, _reference5.fullPath, _extends({}, state[_reference5.fullPath], {
          downloadUrl: state[_reference5.fullPath].downloadUrl || _payload.downloadUrls[0],
          fetchStatus: FetchStatus.LOADED,
          metadata: _payload
        })));
      }

    case STORAGE.METADATA.FAILURE:
      {
        var _reference6 = action.meta.reference;

        return _extends({}, state, defineProperty({}, _reference6.fullPath, _extends({}, state[_reference6.fullPath], { fetchStatus: FetchStatus.FAILED })));
      }

    default:
      return state;
  }
}

var reducer$$1 = batchReducer(combineReducers({
  auth: reducer$1,
  collections: reducer$2,
  listeners: reducer$3,
  queries: reducer$4,
  storage: reducer$5
}));

var lib$1 = createCommonjsModule(function (module, exports) {
exports.__esModule = true;
exports.defaultMemoize = defaultMemoize;
exports.createSelectorCreator = createSelectorCreator;
exports.createStructuredSelector = createStructuredSelector;
function defaultEqualityCheck(a, b) {
  return a === b;
}

function areArgumentsShallowlyEqual(equalityCheck, prev, next) {
  if (prev === null || next === null || prev.length !== next.length) {
    return false;
  }

  // Do this in a for loop (and not a `forEach` or an `every`) so we can determine equality as fast as possible.
  var length = prev.length;
  for (var i = 0; i < length; i++) {
    if (!equalityCheck(prev[i], next[i])) {
      return false;
    }
  }

  return true;
}

function defaultMemoize(func) {
  var equalityCheck = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : defaultEqualityCheck;

  var lastArgs = null;
  var lastResult = null;
  // we reference arguments instead of spreading them for performance reasons
  return function () {
    if (!areArgumentsShallowlyEqual(equalityCheck, lastArgs, arguments)) {
      // apply arguments instead of spreading for performance.
      lastResult = func.apply(null, arguments);
    }

    lastArgs = arguments;
    return lastResult;
  };
}

function getDependencies(funcs) {
  var dependencies = Array.isArray(funcs[0]) ? funcs[0] : funcs;

  if (!dependencies.every(function (dep) {
    return typeof dep === 'function';
  })) {
    var dependencyTypes = dependencies.map(function (dep) {
      return typeof dep;
    }).join(', ');
    throw new Error('Selector creators expect all input-selectors to be functions, ' + ('instead received the following types: [' + dependencyTypes + ']'));
  }

  return dependencies;
}

function createSelectorCreator(memoize) {
  for (var _len = arguments.length, memoizeOptions = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    memoizeOptions[_key - 1] = arguments[_key];
  }

  return function () {
    for (var _len2 = arguments.length, funcs = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      funcs[_key2] = arguments[_key2];
    }

    var recomputations = 0;
    var resultFunc = funcs.pop();
    var dependencies = getDependencies(funcs);

    var memoizedResultFunc = memoize.apply(undefined, [function () {
      recomputations++;
      // apply arguments instead of spreading for performance.
      return resultFunc.apply(null, arguments);
    }].concat(memoizeOptions));

    // If a selector is called with the exact same arguments we don't need to traverse our dependencies again.
    var selector = defaultMemoize(function () {
      var params = [];
      var length = dependencies.length;

      for (var i = 0; i < length; i++) {
        // apply arguments instead of spreading and mutate a local list of params for performance.
        params.push(dependencies[i].apply(null, arguments));
      }

      // apply arguments instead of spreading for performance.
      return memoizedResultFunc.apply(null, params);
    });

    selector.resultFunc = resultFunc;
    selector.recomputations = function () {
      return recomputations;
    };
    selector.resetRecomputations = function () {
      return recomputations = 0;
    };
    return selector;
  };
}

var createSelector = exports.createSelector = createSelectorCreator(defaultMemoize);

function createStructuredSelector(selectors) {
  var selectorCreator = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : createSelector;

  if (typeof selectors !== 'object') {
    throw new Error('createStructuredSelector expects first argument to be an object ' + ('where each property is a selector, instead received a ' + typeof selectors));
  }
  var objectKeys = Object.keys(selectors);
  return selectorCreator(objectKeys.map(function (key) {
    return selectors[key];
  }), function () {
    for (var _len3 = arguments.length, values = Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
      values[_key3] = arguments[_key3];
    }

    return values.reduce(function (composition, value, index) {
      composition[objectKeys[index]] = value;
      return composition;
    }, {});
  });
}
});

unwrapExports(lib$1);
var lib_1 = lib$1.defaultMemoize;
var lib_2 = lib$1.createSelectorCreator;
var lib_3 = lib$1.createStructuredSelector;
var lib_4 = lib$1.createSelector;

var selectOptionDefaults = {
  subscribe: true
};

var stroageOptionDefaults = {
  metadata: false
};

var emptyArray$1 = [];

var singleUndefined = { fetchStatus: FetchStatus.NONE, doc: undefined };
var collectionUndefiend = { fetchStatus: FetchStatus.NONE, docs: emptyArray$1 };

var selectQueries = function selectQueries(state) {
  return state.queries;
};

var initSelect = function initSelect(store) {
  return function (query, selectOptions) {
    var options = _extends({}, selectOptionDefaults, selectOptions);
    var queryId = getQueryId(query);
    var queryPath = getQueryPath(query);
    var collectionQueryPath = getCollectionQueryPath(query);
    var isDocument = collectionQueryPath !== queryPath;

    var selectStoreQuery = function selectStoreQuery(state) {
      return state.queries[queryId];
    };
    var selectCollection = function selectCollection(state) {
      return state.collections[collectionQueryPath];
    };

    var selector = lib_4([selectStoreQuery, selectCollection], function (storeQuery, collection) {
      if (storeQuery && collection) {
        var documentIds = storeQuery.documentIds,
            fetchStatus = storeQuery.fetchStatus;

        if (documentIds) {
          var docs = documentIds.map(function (id) {
            return collection[id];
          }).filter(Boolean);
          return isDocument ? { fetchStatus: fetchStatus, doc: docs[0] } : { fetchStatus: fetchStatus, docs: docs };
        }
      }
      return isDocument ? singleUndefined : collectionUndefiend;
    });

    return function () {
      var actions = [addQuery(query)];
      if (options.subscribe) {
        actions.push(addListener(query));
      }
      store.dispatch(actions);
      return selector;
    };
  };
};

var initSelectAuth = function initSelectAuth(auth$$1, userCollection) {
  var loggedOut = { fetchStatus: FetchStatus.LOADED, doc: undefined };
  var selectUid = function selectUid(state) {
    return state.auth.uid;
  };
  var selectStoreQuery = lib_4([selectUid, selectQueries], function (uid, queries) {
    return userCollection && queries ? queries['auth|' + userCollection + '/' + uid] : undefined;
  });
  var selectUsersCollection = function selectUsersCollection(state) {
    return userCollection ? state.collections[userCollection] : undefined;
  };
  var selectUserData = lib_4([selectUid, selectUsersCollection], function (uid, users) {
    return users ? users[uid] : undefined;
  });
  var selectCurrentUser = function selectCurrentUser() {
    return auth$$1.currentUser ? JSON.stringify(auth$$1.currentUser.toJSON()) : undefined;
  };

  var selector = lib_4([selectUid, selectCurrentUser, selectStoreQuery, selectUserData], function (uid, currentUser, storeQuery, doc) {
    if (!uid) {
      return loggedOut;
    }
    var fetchStatus = storeQuery ? storeQuery.fetchStatus : !userCollection ? FetchStatus.LOADED : FetchStatus.NONE;
    return {
      fetchStatus: fetchStatus,
      doc: userCollection ? doc : {} // use a new object if no userCollection to cache bust
    };
  });

  return selector;
};

var initSelectStorage = function initSelectStorage(store) {
  return function (ref, storageOptions) {
    var options = _extends({}, stroageOptionDefaults, storageOptions);
    var actionCreator = options.metadata ? getStorageMetadata : getStorageDownloadUrl;
    var selector = function selector(state) {
      return state.storage[ref.fullPath];
    };
    return function () {
      store.dispatch(actionCreator(ref));
      return selector;
    };
  };
};

var lib$2 = createCommonjsModule(function (module, exports) {
exports.__esModule = true;
function createThunkMiddleware(extraArgument) {
  return function (_ref) {
    var dispatch = _ref.dispatch,
        getState = _ref.getState;
    return function (next) {
      return function (action) {
        if (typeof action === 'function') {
          return action(dispatch, getState, extraArgument);
        }

        return next(action);
      };
    };
  };
}

var thunk = createThunkMiddleware();
thunk.withExtraArgument = createThunkMiddleware;

exports['default'] = thunk;
});

var thunk = unwrapExports(lib$2);

var store = void 0;

function init(app, userCollection) {
  if (store) {
    throw new Error('Cannot initialize store more than once.');
  }

  var firestore$$1 = firebase.firestore(app);
  var auth$$1 = firebase.auth(app);

  var thunkArgs = { auth: auth$$1, firestore: firestore$$1 };
  var middleware = [thunk.withExtraArgument(thunkArgs), batchMiddleware];

  if (process.env.NODE_ENV !== 'production') {
    var createLogger = require('redux-logger').createLogger;
    var logger = createLogger({ collapsed: true, diff: true });
    middleware.push(logger);
  }

  store = createStore(reducer$$1, applyMiddleware.apply(undefined, middleware));
  if (process.env.NODE_ENV !== 'production') {
    window.redux = store;
  }

  var select = initSelect(store);
  var selectAuth = initSelectAuth(auth$$1, userCollection);
  var selectStorage = initSelectStorage(store);

  var currentUser = auth$$1.currentUser;
  var currentUid = void 0;
  if (currentUser) {
    currentUid = currentUser.uid;
    store.dispatch(setUser(currentUser, userCollection));
  }

  return new Promise(function (resolve, reject) {
    auth$$1.onAuthStateChanged(function (newUser) {
      store.dispatch(setUser(newUser, userCollection)).then(function () {
        resolve({ app: app, select: select, selectAuth: selectAuth, selectStorage: selectStorage, store: store });
      }).catch(function (error) {
        reject(error);
      });
      if (newUser) {
        currentUid = newUser.uid;
      } else {
        store.dispatch(unsetUser(currentUid, userCollection));
      }
    }, function (error) {
      reject(error);
    });
  });
}

exports['default'] = init;
exports.connect = connect;
exports.connectAuth = connectAuth;
exports.FetchStatus = FetchStatus;
exports.Provider = Provider;
exports.resolveInitialFetchStatus = resolveInitialFetchStatus;
exports.resolveFetchStatus = resolveFetchStatus;
//# sourceMappingURL=index.js.map
