'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.connect = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var connect = exports.connect = function connect(getSelectors) {
  return function (WrappedComponent) {
    var _class, _temp, _initialiseProps;

    return _temp = _class = function (_Component) {
      _inherits(_class, _Component);

      function _class(props, context) {
        _classCallCheck(this, _class);

        var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, props, context));

        _initialiseProps.call(_this);

        _this.state = {};
        return _this;
      }

      _createClass(_class, [{
        key: 'componentWillMount',
        value: function componentWillMount() {
          var _this2 = this;

          var _context$firebase = this.context.firebase,
              auth = _context$firebase.auth,
              firestore = _context$firebase.firestore,
              select = _context$firebase.select,
              selectStorage = _context$firebase.selectStorage,
              storage = _context$firebase.storage,
              store = _context$firebase.store;

          var selector = function selector(ref, options) {
            if ('firestore' in ref) {
              // $FlowFixMe
              return select(ref, options);
            } else if ('storage' in ref) {
              // $FlowFixMe
              return selectStorage(ref, options);
            }
            throw new Error('Invalid object sent to select.');
          };
          var querySelectors = getSelectors(selector, { auth: auth, firestore: firestore, storage: storage }, this.props);
          this._selectors = Object.keys(querySelectors).reduce(function (memo, propName) {
            var selector = querySelectors[propName];
            memo[propName] = typeof selector === 'function' ? selector() : selector;
            return memo;
          }, {});
          this._unsubscribe = store.subscribe(this._handleState);
          var storeState = store.getState();
          this.setState(function (state) {
            return _this2._reduceSelectors(storeState, state);
          });
        }
      }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
          if (this._unsubscribe) {
            this._unsubscribe();
            this._unsubscribe = null;
          }
        }
      }, {
        key: 'render',
        value: function render() {
          var _context$firebase2 = this.context.firebase,
              auth = _context$firebase2.auth,
              firestore = _context$firebase2.firestore,
              messaging = _context$firebase2.messaging,
              storage = _context$firebase2.storage;

          return _react2.default.createElement(WrappedComponent, _extends({}, this.props, this.state, {
            auth: auth,
            firestore: firestore,
            messaging: messaging,
            storage: storage
          }));
        }
      }]);

      return _class;
    }(_react.Component), _class.displayName = 'Connect', _class.WrappedComponent = WrappedComponent, _class.contextTypes = {
      firebase: _propTypes.object.isRequired
    }, _initialiseProps = function _initialiseProps() {
      var _this3 = this;

      this._handleState = function () {
        if (_this3._unsubscribe) {
          var _store = _this3.context.firebase.store;

          var storeState = _store.getState();
          _this3.setState(function (state) {
            return _this3._reduceSelectors(storeState, state);
          });
        }
      };

      this._reduceSelectors = function (storeState, state) {
        return Object.keys(_this3._selectors).reduce(function (memo, key) {
          var selector = _this3._selectors[key];
          state[key] = typeof selector === 'function' ? selector(storeState, _this3.props) : selector;
          return state;
        }, state);
      };
    }, _temp;
  };
};

exports.default = connect;
//# sourceMappingURL=connect.js.map