'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.connectAuth = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _fetchStatus2 = require('./modules/fetchStatus');

var _propTypes = require('prop-types');

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var emptyObject = {};

var connectAuth = exports.connectAuth = function connectAuth(handleAuthStatus, WrappedLoadingComponent) {
  return function (WrappedComponent) {
    var _class, _temp;

    return _temp = _class = function (_Component) {
      _inherits(_class, _Component);

      function _class(props, context) {
        _classCallCheck(this, _class);

        var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, props, context));

        _this._handleState = function () {
          if (_this._unsubscribe) {
            var _this$context$firebas = _this.context.firebase,
                _auth = _this$context$firebas.auth,
                _selectAuth = _this$context$firebas.selectAuth,
                _store = _this$context$firebas.store;

            var _selectAuth2 = _selectAuth(_store.getState()),
                _doc = _selectAuth2.doc,
                _fetchStatus = _selectAuth2.fetchStatus;

            if (handleAuthStatus && !_this._loaded && _fetchStatus === _fetchStatus2.FetchStatus.LOADED) {
              var blockHandling = handleAuthStatus({ doc: _doc, fetchStatus: _fetchStatus }, _auth, _this.props);
              if (blockHandling === false) {
                return;
              }
            }
            _this.setState(function () {
              return { doc: _doc, fetchStatus: _fetchStatus };
            });
          }
        };

        _this.state = { doc: emptyObject, fetchStatus: _fetchStatus2.FetchStatus.LOADING };
        _this._loaded = false;
        return _this;
      }

      _createClass(_class, [{
        key: 'componentWillMount',
        value: function componentWillMount() {
          var store = this.context.firebase.store;

          this._unsubscribe = store.subscribe(this._handleState);
          this._handleState();
        }
      }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
          if (this._unsubscribe) {
            this._unsubscribe();
            this._unsubscribe = null;
          }
        }
      }, {
        key: 'componentWillUpdate',
        value: function componentWillUpdate(nextProps, nextState) {
          var prevState = this.state;
          var auth = this.context.firebase.auth;

          if (nextState.fetchStatus === _fetchStatus2.FetchStatus.LOADED || nextState.fetchStatus === _fetchStatus2.FetchStatus.FAILED) {
            this._loaded = true;
          }
          if (handleAuthStatus && prevState !== nextState) {
            var _action = prevState.doc && !nextState.doc ? 'signout' : !prevState.doc && nextState.doc ? 'signin' : undefined;
            handleAuthStatus({ action: _action, doc: nextState.doc, fetchStatus: nextState.fetchStatus }, auth, nextProps);
          }
        }
      }, {
        key: 'render',
        value: function render() {
          var _context$firebase = this.context.firebase,
              auth = _context$firebase.auth,
              firestore = _context$firebase.firestore,
              messaging = _context$firebase.messaging,
              storage = _context$firebase.storage;
          var _state = this.state,
              fetchStatus = _state.fetchStatus,
              doc = _state.doc;

          var props = {
            auth: auth,
            authFetchStatus: fetchStatus,
            authUserDoc: doc,
            firestore: firestore,
            messaging: messaging,
            storage: storage
          };
          if (this._loaded && fetchStatus === _fetchStatus2.FetchStatus.LOADING) {
            return _react2.default.createElement(WrappedComponent, _extends({}, this.props, props));
          }
          switch (fetchStatus) {
            case _fetchStatus2.FetchStatus.LOADED:
            case _fetchStatus2.FetchStatus.FAILED:
              {
                return _react2.default.createElement(WrappedComponent, _extends({}, this.props, props));
              }
            default:
              return WrappedLoadingComponent ? _react2.default.createElement(WrappedLoadingComponent, _extends({}, this.props, props)) : null;
          }
        }
      }]);

      return _class;
    }(_react.Component), _class.displayName = 'ConnectAuth', _class.WrappedComponent = WrappedComponent, _class.contextTypes = {
      firebase: _propTypes.object.isRequired
    }, _temp;
  };
};

exports.default = connectAuth;
//# sourceMappingURL=connectAuth.js.map