'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
var FetchStatus = exports.FetchStatus = {
  LOADING: 'loading',
  LOADED: 'loaded',
  FAILED: 'failed',
  NONE: 'none'
};

var resolveInitialFetchStatus = exports.resolveInitialFetchStatus = function resolveInitialFetchStatus() {
  for (var _len = arguments.length, items = Array(_len), _key = 0; _key < _len; _key++) {
    items[_key] = arguments[_key];
  }

  var statuses = items.map(function (item) {
    return item.fetchStatus;
  });
  if (statuses.some(function (status) {
    return status === FetchStatus.LOADED;
  })) {
    return FetchStatus.LOADED;
  }
  if (statuses.some(function (status) {
    return status === FetchStatus.LOADING;
  })) {
    return FetchStatus.LOADING;
  }
  if (statuses.some(function (status) {
    return status === FetchStatus.FAILED;
  })) {
    return FetchStatus.FAILED;
  }
  return FetchStatus.NONE;
};

var resolveFetchStatus = exports.resolveFetchStatus = function resolveFetchStatus() {
  for (var _len2 = arguments.length, items = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
    items[_key2] = arguments[_key2];
  }

  var statuses = items.map(function (item) {
    return item.fetchStatus;
  });
  if (statuses.some(function (status) {
    return status === FetchStatus.FAILED;
  })) {
    return FetchStatus.FAILED;
  }
  if (statuses.some(function (status) {
    return status === FetchStatus.LOADING;
  })) {
    return FetchStatus.LOADING;
  }
  if (statuses.every(function (status) {
    return status === FetchStatus.LOADED;
  })) {
    return FetchStatus.LOADED;
  }
  return FetchStatus.NONE;
};
//# sourceMappingURL=fetchStatus.js.map