'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.reducer = reducer;

var _query = require('../modules/query');

var _actions = require('../actions');

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var defaultState = {};
var emptyObject = {};

function reducer() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defaultState;
  var action = arguments[1];

  switch (action.type) {
    case _actions.COLLECTIONS.MODIFY_ONE:
      {
        var meta = action.meta,
            payload = action.payload;

        if (!(payload && payload.id)) {
          return state;
        }

        var path = (0, _query.getCollectionQueryPath)(meta.query);
        return _extends({}, state, _defineProperty({}, path, _extends({}, state[path], _defineProperty({}, payload.id, _extends({ id: payload.id }, payload.data())))));
      }

    case _actions.COLLECTIONS.MODIFY:
      {
        var _meta = action.meta,
            _payload = action.payload;

        if (!_meta || !(_payload && _payload.docChanges)) {
          return state;
        }

        var _path = (0, _query.getCollectionQueryPath)(_meta.query);

        // $FlowFixMe
        var newPathState = _payload.docChanges.reduce(function (newState, change) {
          var doc = change.doc,
              changeType = change.type;

          var oldData = newState[doc.id] || emptyObject;
          switch (changeType) {
            case 'added':
              {
                if (!(doc.id in newState)) {
                  newState[doc.id] = _extends({
                    id: doc.id
                  }, change.doc.data());
                }
                break;
              }

            case 'modified':
              newState[doc.id] = _extends({}, oldData, {
                id: doc.id
              }, change.doc.data());
              break;

            case 'removed':
              delete newState[doc.id];
              break;
            // no default
          }
          return newState;
        }, state[_path] || {});
        return _extends({}, state, _defineProperty({}, _path, newPathState));
      }

    case _actions.COLLECTIONS.REMOVE:
      {
        var _meta2 = action.meta,
            _id = action.payload.id;

        var _path2 = (0, _query.getCollectionQueryPath)(_meta2.query);
        var pathDocs = _extends({}, state[_path2]);
        delete pathDocs[_id];
        return _extends({}, state, _defineProperty({}, _path2, pathDocs));
      }

    default:
      return state;
  }
}
//# sourceMappingURL=collections.js.map