'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.reducer = reducer;

var _actions = require('../actions');

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var defaultState = {};

function reducer() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defaultState;
  var action = arguments[1];

  switch (action.type) {
    case _actions.LISTENERS.ADD:
      {
        var _queryId = action.meta.queryId,
            payload = action.payload;

        return _extends({}, state, _defineProperty({}, _queryId, {
          unsubscribe: payload
        }));
      }

    case _actions.LISTENERS.REMOVE:
      {
        var _queryId2 = action.meta.queryId;

        var newState = _extends({}, state);
        delete newState[_queryId2];
        return newState;
      }

    default:
      return state;
  }
}
//# sourceMappingURL=listeners.js.map