'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.reducer = reducer;

var _fetchStatus = require('../modules/fetchStatus');

var _actions = require('../actions');

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var defaultState = {};

function reducer() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defaultState;
  var action = arguments[1];

  switch (action.type) {
    case _actions.STORAGE.URL.REQUEST:
      {
        var _reference = action.meta.reference;

        return _extends({}, state, _defineProperty({}, _reference.fullPath, _extends({}, state[_reference.fullPath], { fetchStatus: _fetchStatus.FetchStatus.LOADING })));
      }

    case _actions.STORAGE.URL.SUCCESS:
      {
        var _reference2 = action.meta.reference,
            payload = action.payload;

        return _extends({}, state, _defineProperty({}, _reference2.fullPath, { fetchStatus: _fetchStatus.FetchStatus.LOADED, downloadUrl: payload }));
      }

    case _actions.STORAGE.URL.FAILURE:
      {
        var _reference3 = action.meta.reference;

        return _extends({}, state, _defineProperty({}, _reference3.fullPath, _extends({}, state[_reference3.fullPath], { fetchStatus: _fetchStatus.FetchStatus.FAILED })));
      }

    case _actions.STORAGE.METADATA.REQUEST:
      {
        var _reference4 = action.meta.reference;

        return _extends({}, state, _defineProperty({}, _reference4.fullPath, _extends({}, state[_reference4.fullPath], { fetchStatus: _fetchStatus.FetchStatus.LOADING })));
      }

    case _actions.STORAGE.METADATA.SUCCESS:
      {
        var _reference5 = action.meta.reference,
            _payload = action.payload;

        return _extends({}, state, _defineProperty({}, _reference5.fullPath, _extends({}, state[_reference5.fullPath], {
          downloadUrl: state[_reference5.fullPath].downloadUrl || _payload.downloadUrls[0],
          fetchStatus: _fetchStatus.FetchStatus.LOADED,
          metadata: _payload
        })));
      }

    case _actions.STORAGE.METADATA.FAILURE:
      {
        var _reference6 = action.meta.reference;

        return _extends({}, state, _defineProperty({}, _reference6.fullPath, _extends({}, state[_reference6.fullPath], { fetchStatus: _fetchStatus.FetchStatus.FAILED })));
      }

    default:
      return state;
  }
}
//# sourceMappingURL=storage.js.map